<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Tests\TestCase;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolSObratom;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolSObratom;

/**
 * Class ZoznamPoctuKontrolSObratomTest
 *
 * @package Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects
 */
class ZoznamPoctuKontrolSObratomTest extends TestCase
{
    /**
     *
     */
    public function testInstance()
    {
        $zoznam = new ZoznamPoctuKontrolSObratom();

        self::assertInstanceOf(ZoznamPoctuKontrolSObratom::class, $zoznam);
    }

    /**
     *
     */
    public function testAddInstanciaInejTriedy()
    {
        $zoznam = new ZoznamPoctuKontrolSObratom();

        self::expectException(InvalidArgumentException::class);

        $zoznam->add(new PocetKontrolPodlaDruhu(
            DruhEmisnejKontrolyEnum::PRAVIDELNA(),
            11
        ));
    }

    /**
     *
     */
    public function testAddSubjektFakturacie()
    {
        $zoznam = new ZoznamPoctuKontrolSObratom();

        $pocetKontrolPodlaObratu = new PocetKontrolSObratom(
            78.99,
            1
        );

        $zoznam->add($pocetKontrolPodlaObratu);

        self::assertCount(1, $zoznam);
    }

    /**
     *
     */
    public function testAdd3x()
    {
        $pocet = 3;
        $obrat = 12.34;
        $zoznam = new ZoznamPoctuKontrolSObratom();

        for ($a = 0; $a < $pocet; ++$a) {
            $pocetKontrolPodlaObratu = new PocetKontrolSObratom(
                $obrat,
                1
            );

            $zoznam->add($pocetKontrolPodlaObratu);
        }

        self::assertCount(1, $zoznam);
        self::assertEquals($pocet, $zoznam->current()->pocet());
        self::assertEquals($obrat * $pocet, $zoznam->current()->obrat());
    }
}
